; Initialization file for tssh(libtscore) 0.3

; Per R5RS, up to four deep compositions should be defined
;(define (caar x) (car (car x)))
;(define (cadr x) (car (cdr x)))
;(define (cdar x) (cdr (car x)))
;(define (cddr x) (cdr (cdr x)))
;(define (caaar x) (car (car (car x))))
;(define (caadr x) (car (car (cdr x))))
;(define (cadar x) (car (cdr (car x))))
;(define (caddr x) (car (cdr (cdr x))))
;(define (cdaar x) (cdr (car (car x))))
;(define (cdadr x) (cdr (car (cdr x))))
;(define (cddar x) (cdr (cdr (car x))))
;(define (cdddr x) (cdr (cdr (cdr x))))
;(define (caaaar x) (car (car (car (car x)))))
;(define (caaadr x) (car (car (car (cdr x)))))
;(define (caadar x) (car (car (cdr (car x)))))
;(define (caaddr x) (car (car (cdr (cdr x)))))
;(define (cadaar x) (car (cdr (car (car x)))))
;(define (cadadr x) (car (cdr (car (cdr x)))))
;(define (caddar x) (car (cdr (cdr (car x)))))
;(define (cadddr x) (car (cdr (cdr (cdr x)))))
;(define (cdaaar x) (cdr (car (car (car x)))))
;(define (cdaadr x) (cdr (car (car (cdr x)))))
;(define (cdadar x) (cdr (car (cdr (car x)))))
;(define (cdaddr x) (cdr (car (cdr (cdr x)))))
;(define (cddaar x) (cdr (cdr (car (car x)))))
;(define (cddadr x) (cdr (cdr (car (cdr x)))))
;(define (cdddar x) (cdr (cdr (cdr (car x)))))
;(define (cddddr x) (cdr (cdr (cdr (cdr x)))))


;(define-syntax cond
;  (syntax-rules (else =>)
;    ((cond (else result1 result2 ...))
;     (begin result1 result2 ...))
;    ((cond (test => result))
;     (let ((temp test))
;       (if temp (result temp))))
;    ((cond (test => result) clause1 clause2 ...)
;     (let ((temp test))
;       (if temp
;	   (result temp)
;	   (cond clause1 clause2 ...))))
;    ((cond (test)) test)
;    ((cond (test) clause1 clause2 ...)
;     (let ((temp test))
;       (if temp
;	   temp
;	   (cond clause1 clause2 ...))))
;    ((cond (test result1 result2 ...))
;     (if test (begin result1 result2 ...)))
;    ((cond (test result1 result2 ...)
;	   clause1 clause2 ...)
;     (if test
;	 (begin result1 result2 ...)
;	 (cond clause1 clause2 ...)))))


;(define-syntax case
;  (syntax-rules (else)
;    ((case (key ...)
;       clauses ...)
;     (let ((atom-key (key ...)))
;       (case atom-key clauses ...)))
;    ((case key
;       (else result1 result2 ...))
;     (begin result1 result2 ...))
;    ((case key
;       ((atoms ...) result1 result2 ...))
;     (if (memv key '(atoms ...))
;	 (begin result1 result2 ...)))
;    ((case key
;       ((atoms ...) result1 result2 ...)
;       clause clauses ...)
;     (if (memv key '(atoms ...))
;	 (begin result1 result2 ...)
;	 (case key clause clauses ...)))))


;(define-syntax and
;  (syntax-rules ()
;    ((and) #t)
;    ((and test) test)
;    ((and test1 test2 ...)
;     (if test1 (and test2 ...) #f))))


;(define-syntax or
;  (syntax-rules ()
;    ((or) #f)
;    ((or test) test)
;    ((or test1 test2 ...)
;     (let ((x test1))
;       (if x x (or test2 ...))))))


;(define-syntax let
;  (syntax-rules ()
;    ((let ((name val) ...) body1 body2 ...)
;     ((lambda (name ...) body1 body2 ...)
;      val ...))
;    ((let tag ((name val) ...) body1 body2 ...)
;     ((letrec ((tag (lambda (name ...)
;		      body1 body2 ...)))
;	tag)
;      val ...))))


;(define-syntax do
;  (syntax-rules ()
;    ((do ((var init step ...) ...)
;	 (test expr ...)
;       command ...)
;     (letrec
;	 ((loop
;	   (lambda (var ...)
;	     (if test
;		 (begin
;		   (if #f #f)
;		   expr ...)
;		 (begin
;		   command
;		   ...
;		   (loop (do "step" var step ...)
;			 ...))))))
;       (loop init ...)))
;    ((do "step" x)
;     x)
;    ((do "step" x y)
;     y)))


(define call/cc call-with-current-continuation)

(define (unzip1-with-cdr . lists)
  (unzip1-with-cdr-iterative lists '() '()))

(define (unzip1-with-cdr-iterative lists cars cdrs)
  (if (null? lists)
      (cons cars cdrs)
      (let ((car1 (caar lists))
	    (cdr1 (cdar lists)))
	(unzip1-with-cdr-iterative 
	 (cdr lists) 
	 (append cars (list car1))
	 (append cdrs (list cdr1))))))

(define (map proc . lists)
  (if (null? lists)
      (apply proc)
      (if (null? (car lists))
	  '()
	  (let* ((unz (apply unzip1-with-cdr lists))
		 (cars (car unz))
		 (cdrs (cdr unz)))
	    (cons (apply proc cars) (apply map (cons proc cdrs)))))))

(define (for-each proc . lists)
  (if (null? lists)
      (apply proc)
      (if (null? (car lists))
	  #t
	  (let* ((unz (apply unzip1-with-cdr lists))
		 (cars (car unz))
		 (cdrs (cdr unz)))
	    (apply proc cars) (apply map (cons proc cdrs))))))


; Random number generator (maximum cycle)
(define *seed* 1)
(define (random-next)
     (let* ((a 16807) (m 2147483647) (q (quotient m a)) (r (modulo m a)))
          (set! *seed*
               (-   (* a (- *seed*
                         (* (quotient *seed* q) q)))
                    (* (quotient *seed* q) r)))
          (if (< *seed* 0) (set! *seed* (+ *seed* m)))
          *seed*))


(gc-verbose #f)
