%define with_system_ca_cert_file 1
%define system_ca_cert_file %{_sysconfdir}/pki/tls/cert.pem

Summary: a GTK+ 2ch.net BBS browser
Name: ochusha
Version: 0.6
Release: 1
URL: http://ochusha.sourceforge.jp
Source: %{name}-%{version}.tar.bz2
License: BSD License
Group: Applications/Internet
BuildRoot: %{_tmppath}/%{name}-root
Requires: gtk2 >= 2.6.0, libxml2 >= 2.6.0, openssl, sqlite, zlib
BuildRequires: gtk2-devel >= 2.6.0, libxml2-devel >= 2.6.0
BuildRequires: openssl-devel, sqlite-devel, zlib-devel


%description
The ochusha is BBS, especially 2ch.net, browser with GUI.
It uses the GTK+ toolkit for all of its interface needs.
The ochusha offers a sort of features such as multi-level
popup view of `response's, embeded and popup view of
images that helps users to interact with BBSs.


%prep
%setup -q

# change desktop entry to use png file at %{icondir}.
%{__sed} -i -e 's|Icon.*$|Icon=ochusha.svg|' ochusha/ochusha.desktop.in


%build

%define help_url file://%{_datadir}/doc/%{name}-%{version}/index.html

%if %{with_system_ca_cert_file}
%configure --with-ca-cert-file=%{system_ca_cert_file} --with-help-url=%{help_url}
%else
%configure --with-help-url=%{help_url}
%endif

%{__make} %{?_smp_flags}


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%makeinstall
#make DESTDIR=$RPM_BUILD_ROOT install


%find_lang %{name}
%find_lang %{name}-properties

%{__cat} %{name}.lang %{name}-properties.lang > all.lang

# Licenses.
if test -f "oniguruma/COPYING"; then
  %{__mv} oniguruma/COPYING oniguruma/COPYING.oniguruma
fi
if test -f "libochushagtk_lgpl/COPYING"; then
  %{__mv} libochushagtk_lgpl/COPYING libochushagtk_lgpl/COPYING.libochushagtk_lgpl
fi

# remove unneeded files
%{__rm} -f %{buildroot}/%{_libdir}/*.a
%{__rm} -f %{buildroot}/%{_libdir}/*.la
%{__rm} -f %{buildroot}/%{_libdir}/*.so
%if %{with_system_ca_cert_file}
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/ca-bundle.crt
%endif
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/*.gif
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/*.html
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/add-bookmark.png
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/board-*.png
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/image-*.png
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/thread-*.png
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/ochusha.png
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/post.png
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/ochusha-accel-map.rc.*
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/ochusha-gtkrc*
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/ochusha-help.css
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/ochusha-init.scm.*
%{__rm} -f %{buildroot}/%{_datadir}/%{name}/ochusha-ui.xml.*

%{__mkdir_p} %{buildroot}/%{_datadir}/applications
%{__ln_s} -f %{_datadir}/%{name}/%{name}.desktop %{buildroot}/%{_datadir}/applications/

# link icon to icondir according to Icon Theme Specification.
%{__mkdir_p} %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/
%{__ln_s} -f ../../../../ochusha/ochusha48.svg \
	  ${buildroot}%{_datadir}/icons/hicolor/scalable/apps/ochusha.svg


%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%post
/sbin/ldconfig
if test -d %{_datadir}/icons/hicolor ; then
  %{_bindir}/gtk-update-icon-cache --force --quiet %{_datadir}/icons/hicolor
fi


%postun
/sbin/ldconfig
if test -d %{_datadir}/icons/hicolor ; then
  %{_bindir}/gtk-update-icon-cache --force --quiet %{_datadir}/icons/hicolor
fi


%files -f all.lang
%defattr(-,root,root)
%doc ACKNOWLEDGEMENT AUTHORS BUGS COPYING ChangeLog NEWS README TODO doc/ochusha-help.css doc/*.gif doc/*.html doc/*.png ochusha/ochusha-accel-map.rc.* ochusha/ochusha-gtkrc* ochusha/ochusha-init.scm.* ochusha/ochusha-ui.xml.* oniguruma/COPYING.oniguruma libochushagtk_lgpl/COPYING.libochushagtk_lgpl
%{_bindir}/ochusha
%{_datadir}/%{name}/*
%{_datadir}/applications/%{name}.desktop
%dir %{_datadir}/%{name}
%{_libdir}/lib*
%{_mandir}/man1/%{name}.1*


%changelog
* Thu Dec 18 2008 <fuyu@users.sourceforge.jp>
- Take help documents into account.

* Wed Dec 10 2008 <fuyu@users.sourceforge.jp>
- Take recently added sample files into account.

* Wed Oct 15 2008 <fuyu@users.sourceforge.jp>
- Add sqlite-devel as a build requirement.

* Mon Oct 06 2008 <fuyu@users.sourceforge.jp>
- Modify to use .svg icon instead of .png for the desktop entry.

* Mon Dec 04 2006 <fuyu@users.sourceforge.jp>
- Newly introduced sample files of UI definition for ochusha will be
  installed as documents instead of package data.

* Sat Nov 18 2006 <fuyu@users.sourceforge.jp>
- COPYING files of oniguruma and libochushagtk_lgpl will be installed
  as COPYING.oniguruma and COPYING.libochushagtk_lgpl.

* Fri Nov 03 2006 <fuyu@users.sourceforge.jp> 0.5.99.62-1
- Version down.
- Specify the CA certificate file bundled within openssl package.

* Mon Sep 19 2005 <fuyu@users.sourceforge.jp> 0.6-1
- Version up.
- Change request fields for gtk+-2.6 and libxml2-2.6.

* Wed Dec 29 2004 <fuyu@users.sourceforge.jp> 0.5.7.1-1
- Version up.
- The ochusha.spec file is polished according to anonymous people's voice.

* Wed Nov 25 2004 <fuyu@users.sourceforge.jp> 0.5.7-1
- Version up.
- The ochusha.spec file is polished according to Matchy's advise.

* Sat Nov 13 2004 <fuyu@users.sourceforge.jp> 0.5.6-1
- Version up.
- The ochusha.spec file is now generated automatically.
- Some hardcoded build/install rules are replaced with common macros.
- Post install/uninstall rules are modified to link/unlink the
  ochusha.desktop file for menu.

* Sat Jul 03 2004 <yuhei@users.sourceforge.jp> 0.5.5-1
- Version up.

* Sun Jun 20 2004 <yuhei@users.sourceforge.jp> 0.5.4.10-1
- Version up.

* Wed Jun 16 2004 <yuhei@users.sourceforge.jp> 0.5.4.9-1
- Version up.

* Tue Jun 15 2004 <yuhei@users.sourceforge.jp> 0.5.4.8-1
- Version up.

* Mon Jun 14 2004 <yuhei@users.sourceforge.jp> 0.5.4.7-1
- Version up.

* Sun Jun 13 2004 <yuhei@users.sourceforge.jp> 0.5.4.5-1
- Version up.

* Sat Jun 12 2004 <yuhei@users.sourceforge.jp> 0.5.4.4-1
- Version up.

* Sun Jun 06 2004 <yuhei@users.sourceforge.jp> 0.5.4.3-1
- Version up.

* Mon May 24 2004 <yuhei@users.sourceforge.jp> 0.5.4.2-1
- Version up.

* Mon May 17 2004 <yuhei@users.sourceforge.jp> 0.5.4.1-1
- Version up.

* Sun May 02 2004 <yuhei@users.sourceforge.jp> 0.5.2-1
- Version up.

* Sat Apr 10 2004 <yuhei@users.sourceforge.jp> 0.5.1-1
- Version up.
- Added manfile to filelist.
- Added mandir option to configure script.

* Mon Mar 01 2004 <yuhei@users.sourceforge.jp> 0.5-1
- Version up.
- Changed filelist.

* Wed Jan 28 2004 <yuhei@users.sourceforge.jp> 0.4.10.3-1
- Version up.

* Fri Jan 23 2004 <yuhei@users.sourceforge.jp> 0.4.10.1-1
- Version up.

* Wed Jan 21 2004 <yuhei@users.sourceforge.jp> 0.4.10-1
- Version up.

* Sun Jan 18 2004 <yuhei@users.sourceforge.jp> 0.4.9.7-1
- Version up.

* Sat Jan 17 2004 <yuhei@users.sourceforge.jp> 0.4.9.6-1
- Version up.

* Fri Jan 16 2004 <yuhei@users.sourceforge.jp> 0.4.9.5-1
- Version up.

* Wed Jan 14 2004 <yuhei@users.sourceforge.jp> 0.4.9.4-1
- Version up.

* Wed Jan 14 2004 <yuhei@users.sourceforge.jp> 0.4.9.3-1
- Version up.

* Tue Jan 13 2004 <yuhei@users.sourceforge.jp> 0.4.9.2-1
- Version up.

* Mon Jan 12 2004 <yuhei@users.sourceforge.jp> 0.4.9.1-1
- Version up.

* Tue Jan 01 2004 <yuhei@users.sourceforge.jp> 0.4.8.2-1
- Version up.

* Wed Dec 31 2003 <yuhei@users.sourceforge.jp> 0.4.8.1-1
- Version up.

* Tue Dec 30 2003 <yuhei@users.sourceforge.jp> 0.4.8-1
- Version up.
- Added files about libtsengine.
- Added ochusha-init.scm file.
- Added to run ldconfig when (un)installing. 

* Mon Dec 29 2003 <yuhei@users.sourceforge.jp> 0.4.7.1-1
- Version up.

* Wed Dec 24 2003 <yuhei@users.sourceforge.jp> 0.4.7-1
- Version up.

* Mon Dec 22 2003 <yuhei@users.sourceforge.jp> 0.4.6-1
- Version up.

* Sun Dec 21 2003 <yuhei@users.sourceforge.jp> 0.4.5.10-1
- Version up.

* Fri Dec 19 2003 <yuhei@users.sourceforge.jp> 0.4.5.7-1
- Version up.

* Tue Dec 16 2003 <yuhei@users.sourceforge.jp> 0.4.5.6-1
- Version up.

* Tue Dec 16 2003 <yuhei@users.sourceforge.jp> 0.4.5.5-1
- Version up.

* Sun Dec 14 2003 <yuhei@users.sourceforge.jp> 0.4.5.4-1
- Version up.

* Sat Dec 13 2003 <yuhei@users.sourceforge.jp> 0.4.5.3-1
- Version up.

* Mon Dec 09 2003 <yuhei@users.sourceforge.jp> 0.4.5.1-1
- Version up.

* Sat Dec 06 2003 <yuhei@users.sourceforge.jp> 0.4.5-1
- Version up.
- Added png icon file. 
- Added gtkrc file.

* Thu Nov 27 2003 <yuhei@users.sourceforge.jp> 0.4.4.8-1
- Added xpm icon file.
- Version up.

* Fri Nov 21 2003 <yuhei@users.sourceforge.jp> 0.4.4.3-1
- Version up.

* Fri Nov 14 2003 <yuhei@users.sourceforge.jp> 0.4.4.2-1
- Version up.
- Added some libraries. 

* Mon Jun 23 2003 <yuhei@users.sourceforge.jp> 0.4.3.6-1
- Version up.

* Wed Jun 11 2003 <yuhei@users.sourceforge.jp> 0.4.3.4-1
- Version up.
- changed prefix enviromental valuable.
- changed URL.

* Mon May 19 2003 <yuhei@users.sourceforge.jp> 0.4.3.3-1
- Version up.

* Mon May 12 2003 <yuhei@users.sourceforge.jp> 0.4.3.2-1
- Version up.
- Fixed Group.

* Mon May 12 2003 <yuhei@users.sourceforge.jp> 0.4.2.1-1
- Initial build.
